/// <reference types="react" />
import * as React from 'react';
import { Store } from '@xterm-stack/client-redux';
import 'xterm/lib/xterm.css';
import { IXtermDataProps } from './xterm-data';
export interface IXtermOwnProps {
    styles?: any;
    theme?: any;
    value?: string;
    onFocusChange?: (focused: boolean) => any;
}
export interface IXtermStateProps {
    color?: Store.Color;
    terminalAction?: Store.TerminalAction;
    height?: any;
    left?: any;
    isSendingText?: boolean;
    reload?: boolean;
}
export interface IXtermDispatchProps {
    resetCommand?: () => void;
    resizePanel?: (height: number) => void;
    setError?: (error: string, type: string) => any;
    sendingText?: () => any;
    reloadInstances?: (reload: boolean) => any;
}
export interface IXtermState {
    isFocused?: boolean;
    creating?: boolean;
    finding?: boolean;
    waitingActiveInstance?: boolean;
    textSelected?: boolean;
}
export declare type IXtermProps = IXtermOwnProps & IXtermStateProps & IXtermDispatchProps & IXtermDataProps;
export declare class XtermComponent extends React.Component<IXtermProps, IXtermState> {
    private xterm;
    private xtermInstance;
    private unsubscribe;
    private terminalData;
    private containerRef;
    constructor(props?: IXtermProps, context?: any);
    componentDidMount(): Promise<void>;
    componentWillReceiveProps(nextProps: any): void;
    componentDidUpdate(prevProps: any): void;
    componentWillUnmount(): void;
    private getTheme();
    private setTheme();
    private getXtermInstance();
    private processAction(terminalAction);
    private subscribeTerminalData(instanceId);
    private resetTerminalData(activeInstance, terminalBuffer);
    private createInstance;
    private setActiveInstance(instance);
    private deleteInstance();
    private onResize({cols, rows});
    private onData(text);
    private onKeyDown;
    private fit;
    private searchPrevious;
    private searchNext;
    private onContextmenu;
    private clear;
    private copyText;
    private pasteText;
    private selectAll;
    private closeFinder;
    render(): JSX.Element;
}
